import groovy.lang.Binding;
import helloworlddsl.*;

// ---- A bit of script initialization ----------------------------

// ---- Stock exchange orders DSL ---------------------------------

def ruleStuff() {
	def whenFunc = {
		println "WHEN WHEN WHEN asclosure"; return true;
	}

	def r = addRule "ruleid1234" rule {
		when whenFunc
		perform
		{ 
			println "PERFORMING";
		}
	}
	
	r.doIt()
}

ruleStuff();

//	when { println "2Should when now"; return true }
//	 perform { println "performing now" } 
//}

//of IBM {
//	limitPrice       300
//	allOrNone        false
//	at the value of  { qty * unitPrice - 600 }
//}


// ----- Implementation of the DSL --------------------------------
class RuleBuilder {
	RewriteRule rewriteRule;
	String id;

	RuleBuilder(String id) {
		this.id = id;
		rewriteRule = new RewriteRule(id);
	}
	
	def perform(Closure cOrig) {
		rewriteRule.perform(cOrig);
	}

	def when (Closure cOrig) {
		rewriteRule.when(cOrig);
	}
	
	//def perform
	
	def rule (Closure cOrig) {
		Closure c = cOrig.clone()
		c.delegationStrategy = Closure.DELEGATE_ONLY
		c.delegate = this
		
		c()
		return this
	}
	
	def doIt() {
		rewriteRule.doIt();
	}
	
	String toString() {
		"ID: $id, Closure: $c"
	}
}

// Script helper method to make "order to" silent
// by just creating our current order
def addRule(ruleID) { return new RuleBuilder(ruleID) }
